import * as vscode from 'vscode';
export declare function rndName(): string;
export declare function createRandomFile(contents?: string, fileExtension?: string): Thenable<vscode.Uri>;
export declare function deleteFile(file: vscode.Uri): Thenable<boolean>;
export declare const CURSOR = "$$CURSOR$$";
export declare function withRandomFileEditor(contents: string, fileExtension: string, run: (editor: vscode.TextEditor, doc: vscode.TextDocument) => Thenable<void>): Thenable<boolean>;
export declare const wait: (ms: number) => Promise<void>;
export declare const joinLines: (...args: string[]) => string;
export declare function createTestEditor(uri: vscode.Uri, ...lines: string[]): Promise<vscode.TextEditor>;
export declare function assertEditorContents(editor: vscode.TextEditor, expectedDocContent: string, message?: string): void;
export type VsCodeConfiguration = {
    [key: string]: any;
};
export declare function updateConfig(documentUri: vscode.Uri, newConfig: VsCodeConfiguration): Promise<VsCodeConfiguration>;
export declare const Config: Readonly<{
    readonly autoClosingBrackets: "editor.autoClosingBrackets";
    readonly typescriptCompleteFunctionCalls: "typescript.suggest.completeFunctionCalls";
    readonly insertMode: "editor.suggest.insertMode";
    readonly snippetSuggestions: "editor.snippetSuggestions";
    readonly suggestSelection: "editor.suggestSelection";
    readonly javascriptQuoteStyle: "javascript.preferences.quoteStyle";
    readonly typescriptQuoteStyle: "typescript.preferences.quoteStyle";
}>;
export declare const insertModesValues: readonly string[];
export declare function enumerateConfig(documentUri: vscode.Uri, configKey: string, values: readonly string[], f: (message: string) => Promise<void>): Promise<void>;
export declare function onChangedDocument(documentUri: vscode.Uri, disposables: vscode.Disposable[]): Promise<vscode.TextDocument>;
export declare function retryUntilDocumentChanges(documentUri: vscode.Uri, options: {
    retries: number;
    timeout: number;
}, disposables: vscode.Disposable[], exec: () => Thenable<unknown>): Promise<void | vscode.TextDocument>;
